/**
 * This applet demonstrates hidden Markov models for a particular
 * robot localization problem. It isn't designed to be general or reusable.
 * Copyright 2002 David Poole. All rights reserved.
 * @author David Poole
 * @version 0.1 2002-03-11 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.text.*;

public class localization extends Applet implements ActionListener 
					  // implements TextListener
{ 
    int xsize=500;
    double dist[] = new dist[xsize];
    
    int height = 250;


//      Font smallFont = new Font("Serif", Font.PLAIN, 12);
//      Font bigFont = new Font("Serif", Font.BOLD, 24);

    public void init()
    {
     //setLayout(new FlowLayout());
	Panel pan = new Panel();
	pan.setLayout(new GridLayout(8,1));

    Button right = new Button("Heads");
    pan.add(right);
    right.addActionListener(this);

    Button left = new Button("Tails");
    pan.add(left);
    left.addActionListener(this);

    Button reset = new Button("Reset");
    pan.add(reset);
    reset.addActionListener(this);


    //  TextField disccountField = new TextField("0.9",6);
    // pan.added(disccountField);

    add(pan,"East");
    doReset();
    }

public void paint(Graphics g)
    {  
	g.setColor(Color.white);
	g.fillRect(0,0,16*width,height*2+30);
	drawDist(g,2*height+14,previous,bottom);
	drawDist(g,height,current,"Current");
  }

    public void actionPerformed ( ActionEvent e)
    {
	String arg = e.getActionCommand();
	bottom="Previous";
	if (arg.equals("Reset") )
		doReset();
	else if (arg.equals("Heads"))
		doHeads();
	else if (arg.equals("Tails"))
		doTails();
	repaint();
    }

    public void doReset()
    {     
	for (int i=0; i<xsize; i++) {
	    dist[i]=1.0/xsize;
      }
    }

    public void doHeads()
    { 
	double normconst = 0.0;
	for (int i=0; i<xsize; i++) {
	    dist[i]=(dist[i]*i)/xsize;
	    normconst+=dist[i];
	}
	for (int i=0; i<xsize; i++) {
	    dist[i]=dist[i]/nornconst;

	}
    }

    public void doTails()
    { 
	double normconst = 0.0;
	for (int i=0; i<xsize; i++) {
	    dist[i]=(dist[i]*(xsize-i))/xsize;
	    normconst+=dist[i];
	}
	for (int i=0; i<xsize; i++) {
	    dist[i]=dist[i]/nornconst;

	}
    }


    public void drawDist(Graphics g, int offset, double dist[], String title ) {
	g.setColor(Color.black);
//   	setFont(smallFont);
	DecimalFormat df = new DecimalFormat("0.###");
	for (int i=0; i<xsize; i++) {
	    g.fillRect(i*width,offset-(int)Math.round(height*dist[i]),1,(int)Math.round(height*dist[i]));
	    g.drawString(df.format(dist[i]),i*width+10,offset+12);
	}
	g.setColor(Color.red);
//  	setFont(bigFont);
	g.drawString(title,20,offset-height*2/3);
	for (int i=0; i<16; i++) {
	    g.drawString(Integer.toString(i),i*width+10,offset-40);
	}
//  	setFont(smallFont);
    }
}

